"""Automatic testing.
"""
import os

### RNN_Dense.py


rnn1_sigmoid_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn0_in': [False, False, False, False, False, False, False, False, False],

    'rnn1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

rnn1_tanh_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True],
    'rnn0_in': [False, False, False, False, False, False],

    'rnn1_units': [2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

rnn1_softmax_configs = {
    'rnn0_units': [4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True],
    'rnn0_in': [False, False, False, False, False],

    'rnn1_units': [2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}


rnn01_sigmoid_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

rnn01_tanh_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

rnn01_softmax_configs = {
    'rnn0_units': [4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [False, False, False, False, False],
    'rnn1_trainable': [True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}

sigmoid_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [True, True, True, True, True, True, True, True, True],
    'rnn1_trainable': [True, True, True, True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

tanh_configs = {
    'rnn0_units': [4, 4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [True, True, True, True, True, True],
    'rnn1_trainable': [True, True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

softmax_configs = {
    'rnn0_units': [4, 4, 4, 4, 4],
    'rnn0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn0_sequences': [True, True, True, True, True],
    'rnn0_trainable': [True, True, True, True, True],
    'rnn0_in': [True, True, True, True, True],

    'rnn1_units': [2, 2, 2, 2, 2],
    'rnn1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'rnn1_sequences': [True, True, True, True, True],
    'rnn1_trainable': [True, True, True, True, True],
    'rnn1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}


for configs in [rnn1_sigmoid_configs, rnn1_tanh_configs, rnn1_softmax_configs, rnn01_sigmoid_configs, rnn01_tanh_configs, rnn01_softmax_configs, sigmoid_configs, tanh_configs, softmax_configs]:

    N_RUNS = len(configs['rnn0_units'])

    for run in range(N_RUNS):
        args = []

        for k, v in configs.items():
            args.append(str(v[run]))
        args = ' '.join(args)

        os.system('python3 RNN_Dense.py %s' % args)
